## ros-melodic-rc-genicam-api 2.4.4

=== completion/CMakeLists.txt ===
# This file is part of the rc_genicam_api package.
#
# Copyright (c) 2017 Roboception GmbH
# All rights reserved
#
# Author: Heiko Hirschmueller
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice,
# this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright notice,
# this list of conditions and the following disclaimer in the documentation
# and/or other materials provided with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its contributors
# may be used to endorse or promote products derived from this software without
# specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.

project(completion CXX)

if (UNIX)
  set(ROS_DISTRO $ENV{ROS_DISTRO})

  if (ROS_DISTRO)
    set(COMPLETION_NAME "20.rc-gc.bash")
    install(FILES gc_bash_completion COMPONENT bin DESTINATION etc/catkin/profile.d RENAME ${COMPLETION_NAME})
    set(conffiles etc/catkin/profile.d/${COMPLETION_NAME} PARENT_SCOPE)
  else ()
    set(COMPLETION_NAME "gc_bash_completion")
    install(FILES gc_bash_completion COMPONENT bin DESTINATION /etc/bash_completion.d RENAME ${COMPLETION_NAME})
    set(conffiles /etc/bash_completion.d/${COMPLETION_NAME} PARENT_SCOPE)
  endif ()

endif (UNIX)

=== genicam/CMakeLists.txt ===
project(genicam CXX)

if (UNIX)
  # try to get architecture from compiler
  EXECUTE_PROCESS(COMMAND ${CMAKE_CXX_COMPILER} -dumpmachine COMMAND tr -d '\n' OUTPUT_VARIABLE CXX_MACHINE)
  string(REGEX REPLACE "([a-zA-Z_0-9]+).*" "\\1" ARCHITECTURE ${CXX_MACHINE})
elseif (WIN32)
  if ("${CMAKE_SIZEOF_VOID_P}" STREQUAL "4")
    set(ARCHITECTURE WIN32_i86)
  else ()
    set(ARCHITECTURE WIN64_x64)
  endif ()
endif ()

message(STATUS "Detected architecture ${ARCHITECTURE}")

set(GENICAM_LIB_SUFFIX)

if ("${ARCHITECTURE}" STREQUAL "arm")
  set(GENICAM_LIBRARIES
    libGCBase_gcc46_v3_1
    libMathParser_gcc46_v3_1
    libGenApi_gcc46_v3_1
    libNodeMapData_gcc46_v3_1
    liblog4cpp_gcc46_v3_1
    libXmlParser_gcc46_v3_1
    libLog_gcc46_v3_1
  )
  set(GENICAM_LIBRARIES_DIR ${CMAKE_CURRENT_SOURCE_DIR}/bin/Linux32_ARMhf)
  set(GENICAM_LIB_SUFFIX ".so")
elseif ("${ARCHITECTURE}" STREQUAL "aarch64")
  set(GENICAM_LIBRARIES
    libGCBase_gcc48_v3_1
    libMathParser_gcc48_v3_1
    libGenApi_gcc48_v3_1
    libNodeMapData_gcc48_v3_1
    liblog4cpp_gcc48_v3_1
    libXmlParser_gcc48_v3_1
    libLog_gcc48_v3_1
  )
  set(GENICAM_LIBRARIES_DIR ${CMAKE_CURRENT_SOURCE_DIR}/bin/Linux64_ARM)
  set(GENICAM_LIB_SUFFIX ".so")
elseif ("${ARCHITECTURE}" STREQUAL "i686")
  set(GENICAM_LIBRARIES
    libGCBase_gcc42_v3_1
    libMathParser_gcc42_v3_1
    libGenApi_gcc42_v3_1
    libNodeMapData_gcc42_v3_1
    liblog4cpp_gcc42_v3_1
    libXmlParser_gcc42_v3_1
    libLog_gcc42_v3_1
  )
  set(GENICAM_LIBRARIES_DIR ${CMAKE_CURRENT_SOURCE_DIR}/bin/Linux32_i86)
  set(GENICAM_LIB_SUFFIX ".so")
elseif ("${ARCHITECTURE}" STREQUAL "x86_64")
  set(GENICAM_LIBRARIES
    libGCBase_gcc42_v3_1
    libMathParser_gcc42_v3_1
    libGenApi_gcc42_v3_1
    libNodeMapData_gcc42_v3_1
    liblog4cpp_gcc42_v3_1
    libXmlParser_gcc42_v3_1
    libLog_gcc42_v3_1
  )
  set(GENICAM_LIBRARIES_DIR ${CMAKE_CURRENT_SOURCE_DIR}/bin/Linux64_x64)
  set(GENICAM_LIB_SUFFIX ".so")
elseif ("${ARCHITECTURE}" STREQUAL "WIN32_i86")
  install(FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/bin/Win32_i86/GCBase_MD_VC120_v3_1.dll
    ${CMAKE_CURRENT_SOURCE_DIR}/bin/Win32_i86/GenApi_MD_VC120_v3_1.dll
    ${CMAKE_CURRENT_SOURCE_DIR}/bin/Win32_i86/Log_MD_VC120_v3_1.dll
    ${CMAKE_CURRENT_SOURCE_DIR}/bin/Win32_i86/MathParser_MD_VC120_v3_1.dll
    ${CMAKE_CURRENT_SOURCE_DIR}/bin/Win32_i86/msvcp120.dll
    ${CMAKE_CURRENT_SOURCE_DIR}/bin/Win32_i86/msvcr120.dll
    ${CMAKE_CURRENT_SOURCE_DIR}/bin/Win32_i86/NodeMapData_MD_VC120_v3_1.dll
    ${CMAKE_CURRENT_SOURCE_DIR}/bin/Win32_i86/XmlParser_MD_VC120_v3_1.dll
	COMPONENT bin DESTINATION ${CMAKE_INSTALL_BINDIR}
  )
  set(GENICAM_LIBRARIES
    GCBase_MD_VC120_v3_1
    GenApi_MD_VC120_v3_1
  )
  set(GENICAM_LIBRARIES_DIR ${CMAKE_CURRENT_SOURCE_DIR}/library/CPP/lib/Win32_i86)
  set(GENICAM_LIB_SUFFIX ".lib")
elseif ("${ARCHITECTURE}" STREQUAL "WIN64_x64")
  install(FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/bin/Win64_x64/GCBase_MD_VC120_v3_1.dll
    ${CMAKE_CURRENT_SOURCE_DIR}/bin/Win64_x64/GenApi_MD_VC120_v3_1.dll
    ${CMAKE_CURRENT_SOURCE_DIR}/bin/Win64_x64/Log_MD_VC120_v3_1.dll
    ${CMAKE_CURRENT_SOURCE_DIR}/bin/Win64_x64/MathParser_MD_VC120_v3_1.dll
    ${CMAKE_CURRENT_SOURCE_DIR}/bin/Win64_x64/msvcp120.dll
    ${CMAKE_CURRENT_SOURCE_DIR}/bin/Win64_x64/msvcr120.dll
    ${CMAKE_CURRENT_SOURCE_DIR}/bin/Win64_x64/NodeMapData_MD_VC120_v3_1.dll
    ${CMAKE_CURRENT_SOURCE_DIR}/bin/Win64_x64/XmlParser_MD_VC120_v3_1.dll
	COMPONENT bin DESTINATION ${CMAKE_INSTALL_BINDIR}
  )
  set(GENICAM_LIBRARIES
    GCBase_MD_VC120_v3_1
    GenApi_MD_VC120_v3_1
  )
  set(GENICAM_LIBRARIES_DIR ${CMAKE_CURRENT_SOURCE_DIR}/library/CPP/lib/Win64_x64)
  set(GENICAM_LIB_SUFFIX ".lib")
else ()
  message(FATAL_ERROR "Unknown architecture")
endif ()

set(GENICAM_LIBRARIES_IN_BUILD_DIR)
foreach(GENICAM_LIB ${GENICAM_LIBRARIES})
  set(GENICAM_LIB_FILE "${GENICAM_LIBRARIES_DIR}/${GENICAM_LIB}${GENICAM_LIB_SUFFIX}")
  list(APPEND GENICAM_LIBRARIES_IN_BUILD_DIR "${GENICAM_LIB_FILE}")
endforeach()

install(FILES ${GENICAM_LIBRARIES_IN_BUILD_DIR} COMPONENT bin DESTINATION ${GENICAM_INSTALL_LIBDIRS})

# only install headers if we build and install the shared lib
if (BUILD_SHARED_LIBS)
  install(DIRECTORY library/CPP/include/ COMPONENT dev DESTINATION ${GENICAM_INSTALL_INCLUDEDIRS})
endif ()

=== rc_genicam_api/CMakeLists.txt ===
# This file is part of the rc_genicam_api package.
#
# Copyright (c) 2017 Roboception GmbH
# All rights reserved
#
# Author: Heiko Hirschmueller
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice,
# this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright notice,
# this list of conditions and the following disclaimer in the documentation
# and/or other materials provided with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its contributors
# may be used to endorse or promote products derived from this software without
# specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.

project(rc_genicam_api CXX)

set(src
  exception.cc
  system.cc
  interface.cc
  device.cc
  stream.cc
  cport.cc
  buffer.cc
  config.cc
  image.cc
  imagelist.cc
  image_store.cc
  pointcloud.cc
  ${CMAKE_CURRENT_BINARY_DIR}/project_version.cc
  $<$<PLATFORM_ID:Linux>:gentl_wrapper_linux.cc>
  $<$<PLATFORM_ID:Windows>:gentl_wrapper_win32.cc>)

set(hh
  exception.h
  system.h
  interface.h
  device.h
  stream.h
  buffer.h
  config.h
  image.h
  imagelist.h
  image_store.h
  pointcloud.h
  pixel_formats.h
  ${CMAKE_CURRENT_BINARY_DIR}/project_version.h)

list(APPEND MSVC_DISABLED_WARNINGS
    "/wd4003"
    "/wd4514"
    "/wd4710"
    "/wd4820"
    "/wd4435"
    "/wd4668"
    "/wd4127"
    "/wd4265"
    "/wd4996"
    "/wd4437"
    "/wd4571"
    "/wd4355"
    "/wd4061"
    "/wd4800"
    "/wd4711"
    "/wd4774"
    "/wd4625"
    "/wd4626"
    "/wd5026"
    "/wd5027"
    "/wd5039")

if (UNIX)
  set(GENTL_INSTALL_PATH "${CMAKE_INSTALL_FULL_LIBDIR}/${PROJECT_NAME_LOWER}")
elseif (WIN32)
  set(GENTL_INSTALL_PATH "${CMAKE_INSTALL_FULL_BINDIR}")
endif ()

if (PNG_FOUND)
  include_directories(${PNG_INCLUDE_DIRS})
  add_definitions(-DINCLUDE_PNG)
  add_definitions(${PNG_DEFINITIONS})
endif ()

add_library(rc_genicam_api_private_properties INTERFACE)
add_library(${PROJECT_NAMESPACE}::rc_genicam_api_private_properties ALIAS
    rc_genicam_api_private_properties)

target_link_libraries(rc_genicam_api_private_properties
  INTERFACE
    $<$<CXX_COMPILER_ID:GNU>:dl>)
target_compile_options(rc_genicam_api_private_properties
  INTERFACE
    $<$<CXX_COMPILER_ID:GNU>:-Wall>
    $<$<CXX_COMPILER_ID:GNU>:-Wno-unknown-pragmas>
    $<$<CXX_COMPILER_ID:MSVC>:${MSVC_DISABLED_WARNINGS}>)
target_compile_definitions(rc_genicam_api_private_properties
  INTERFACE
    -DGENTL_INSTALL_PATH=\"${GENTL_INSTALL_PATH}\")

add_library(rc_genicam_api_static STATIC ${src})
add_library(${PROJECT_NAMESPACE}::rc_genicam_api_static ALIAS rc_genicam_api_static)

target_include_directories(rc_genicam_api_static
  PUBLIC
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
    $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}>
    $<BUILD_INTERFACE:${CMAKE_BINARY_DIR}>)
target_link_libraries(rc_genicam_api_static
  PUBLIC
    ${PROJECT_NAMESPACE}::genicam
    ${PNG_LIBRARIES}
  PRIVATE
    ${PROJECT_NAMESPACE}::rc_genicam_api_private_properties)
target_compile_options(rc_genicam_api_static
  PUBLIC
    $<$<CXX_COMPILER_ID:MSVC>:/DGENICAM_NO_AUTO_IMPLIB>)

if (BUILD_SHARED_LIBS)
  add_library(rc_genicam_api SHARED ${src})
  add_library(${PROJECT_NAMESPACE}::rc_genicam_api ALIAS rc_genicam_api)

  target_include_directories(rc_genicam_api
    PUBLIC
      $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
      $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}>
      $<BUILD_INTERFACE:${CMAKE_BINARY_DIR}>)
  target_link_libraries(rc_genicam_api
    PUBLIC
      ${PROJECT_NAMESPACE}::genicam
    PRIVATE
      ${PNG_LIBRARIES}
      ${PROJECT_NAMESPACE}::rc_genicam_api_private_properties)
  target_compile_options(rc_genicam_api
    PUBLIC
      $<$<CXX_COMPILER_ID:MSVC>:/DGENICAM_NO_AUTO_IMPLIB>)

  set_target_properties(rc_genicam_api PROPERTIES SOVERSION ${abiversion})

  install(TARGETS rc_genicam_api
      EXPORT PROJECTTargets
      COMPONENT bin
      LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
      ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
      RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif ()

# only install headers if we build and install the shared lib
if (BUILD_SHARED_LIBS)
  install(FILES ${hh} COMPONENT dev DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/rc_genicam_api)
endif ()

=== tools/CMakeLists.txt ===
# This file is part of the rc_genicam_api package.
#
# Copyright (c) 2017 Roboception GmbH
# All rights reserved
#
# Author: Heiko Hirschmueller
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice,
# this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright notice,
# this list of conditions and the following disclaimer in the documentation
# and/or other materials provided with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its contributors
# may be used to endorse or promote products derived from this software without
# specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.

project(tools CXX)

# build programs

add_executable(gc_info gc_info.cc)
target_link_libraries(gc_info
  PRIVATE
      ${PROJECT_NAMESPACE}::rc_genicam_api_static)
target_compile_options(gc_info PRIVATE $<$<CXX_COMPILER_ID:GNU>:-Wall>)

add_executable(gc_config gc_config.cc)
target_link_libraries(gc_config
  PRIVATE
    ${PROJECT_NAMESPACE}::rc_genicam_api_static)
target_compile_options(gc_config PRIVATE $<$<CXX_COMPILER_ID:GNU>:-Wall>)

add_executable(gc_stream gc_stream.cc)
target_link_libraries(gc_stream
  PRIVATE
    ${PROJECT_NAMESPACE}::rc_genicam_api_static)
target_compile_options(gc_stream PRIVATE $<$<CXX_COMPILER_ID:GNU>:-Wall>)

if (UNIX)
  find_package(Threads REQUIRED)
  target_link_libraries(gc_stream
    PRIVATE
      ${CMAKE_THREAD_LIBS_INIT})
endif ()

add_executable(gc_pointcloud gc_pointcloud.cc)
target_link_libraries(gc_pointcloud
  PRIVATE
    ${PROJECT_NAMESPACE}::rc_genicam_api_static)
target_compile_options(gc_pointcloud PRIVATE $<$<CXX_COMPILER_ID:GNU>:-Wall>)

# install tools

install(TARGETS gc_info
    EXPORT PROJECTTargets
    COMPONENT bin
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(TARGETS gc_config
    EXPORT PROJECTTargets
    COMPONENT bin
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(TARGETS gc_stream
    EXPORT PROJECTTargets
    COMPONENT bin
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(TARGETS gc_pointcloud
    EXPORT PROJECTTargets
    COMPONENT bin
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

=== debian/changelog ===
ros-melodic-rc-genicam-api (2.4.4-1stretch) stretch; urgency=high

  * Trying to fix problem that interface handle becomes invalid

 -- Felix Ruess <felix.ruess@roboception.de>  Thu, 22 Oct 2020 22:00:00 -0000

ros-melodic-rc-genicam-api (2.4.3-1stretch) stretch; urgency=high

  * Improved reporting of exceptions

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 21 Oct 2020 22:00:00 -0000

ros-melodic-rc-genicam-api (2.4.2-1stretch) stretch; urgency=high

  * Added some optional Roboception specific information to the parameter files
  * Fixed crashing of gc_info if getting nodemap from device fails
  * Fixed getEnum crash if enum doesn't contain a value

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 21 Oct 2020 22:00:00 -0000

ros-melodic-rc-genicam-api (2.4.1-1stretch) stretch; urgency=high

  * Enabled building for ROS focal on gitlab

 -- Felix Ruess <felix.ruess@roboception.de>  Thu, 30 Jul 2020 22:00:00 -0000

ros-melodic-rc-genicam-api (2.4.0-1stretch) stretch; urgency=high

  * gc_stream now puts status of GPIO out and in lines in two separate bit fields in file name

 -- Felix Ruess <felix.ruess@roboception.de>  Sun, 26 Jul 2020 22:00:00 -0000

ros-melodic-rc-genicam-api (2.3.7-1stretch) stretch; urgency=high

  * Improved finding devices, e.g. by IP if GenTL provider supports this

 -- Felix Ruess <felix.ruess@roboception.de>  Sun, 26 Jul 2020 22:00:00 -0000

ros-melodic-rc-genicam-api (2.3.6-1stretch) stretch; urgency=high

  * Fixed compile bug under Windows

 -- Felix Ruess <felix.ruess@roboception.de>  Thu, 16 Apr 2020 22:00:00 -0000

ros-melodic-rc-genicam-api (2.3.5-1stretch) stretch; urgency=high

  * ensure that downscale factor doesn't lead to division by zero
  * remove build_export_depend on catkin from package.xml

 -- Felix Ruess <felix.ruess@roboception.de>  Sun, 05 Apr 2020 22:00:00 -0000

ros-melodic-rc-genicam-api (2.3.4-1stretch) stretch; urgency=high

  * Workaround for Baumer GenTL GEV interface enumeration bug

 -- Felix Ruess <felix.ruess@roboception.de>  Sat, 14 Mar 2020 23:00:00 -0000

ros-melodic-rc-genicam-api (2.3.3-1stretch) stretch; urgency=high

  * fix version in package.xml
  * fix Dockerfile

 -- Felix Ruess <felix.ruess@roboception.de>  Thu, 05 Mar 2020 23:00:00 -0000

ros-melodic-rc-genicam-api (2.3.2-1stretch) stretch; urgency=high

  * add libpng-dev dependency in package.xml

 -- Felix Ruess <felix.ruess@roboception.de>  Thu, 05 Mar 2020 23:00:00 -0000

ros-melodic-rc-genicam-api (2.3.1-1stretch) stretch; urgency=high

  * Reporting full name of stored images, including suffix

 -- Felix Ruess <felix.ruess@roboception.de>  Thu, 09 Jan 2020 23:00:00 -0000

ros-melodic-rc-genicam-api (2.3.0-1stretch) stretch; urgency=high

  * Tool gc_stream:
    * now also stores the exposure time and gain in parameter files
    * added storing 16 bit images
    * Added parameter '-f png' for storing images in PNG format
    * Reporting all stored images (IntensityRight was missing)
  * Tool gc_info:
    * print User defined name
  * Refactoring:
    * Moved functions to store images from gc_stream tool into core library
    * Moved function to store point cloud from tool to library
  * Fixed:
    * Do not return device if it can be found on different producers
    * reporting device name instead of test option when misspelling the device in 'gc_stream -t <device> ...' call
    * net_perf_check.sh: fix getting mtu

 -- Felix Ruess <felix.ruess@roboception.de>  Thu, 19 Dec 2019 23:00:00 -0000

ros-melodic-rc-genicam-api (2.2.3-1stretch) stretch; urgency=high

  * Fixed Windows install issues
  * Fixing segfault in Buffer::getTLType()

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 24 Jul 2019 22:00:00 -0000

ros-melodic-rc-genicam-api (2.2.2-1stretch) stretch; urgency=high

  * Set TLParamsLocked before requesting maximum buffer size
  * Only free as many buffers as allocated to avoid errors off GenTL producer
  * Request global buffer YPadding only for none multipart buffers to avoid errors of GenTL producer

 -- Felix Ruess <felix.ruess@roboception.de>  Mon, 24 Jun 2019 22:00:00 -0000

ros-melodic-rc-genicam-api (2.2.1-1stretch) stretch; urgency=high

  * Automatically splitting the stereo images in rc_visards special combined format into Intenstiy and IntensityRight images
  * Using TLParamsLocked correctly in streaming class as some cameras require this
  * gc_stream now disables component Intensity if IntensityCombined is enabled
  * gc_stream now creates parameter file for each Intensity image as well
  * Increased timeout for updating the device list to 100 ms as 10 ms can be too less for some cameras / producers

 -- Felix Ruess <felix.ruess@roboception.de>  Mon, 10 Jun 2019 22:00:00 -0000

ros-melodic-rc-genicam-api (2.2.0-1stretch) stretch; urgency=high

  * gc_info does not report not implemented parameters any more
  * gc_info can now also only print specified nodes (which can be a category) by appending the node name with '?' to the device id.
  * gc_stream can now measure frequency and latency of incomming buffers
  * Windows: look for transport layer in folder of rc_genicam_api.dll
  * support modern cmake
    - A "meta target" for all Genicam targets is defined, rc_genicam_api::genicam, on which rc_genicam_api::rc_genicam_api depends publicly.
    - Compile options and definitions of rc_genicam_api are set to private, only /DGENICAM_NO_AUTO_IMPLIB is public
    - Install paths are defined using GNUInstallDirs
  * update Baumer GenTL providers to 2.9.2.22969
    - Support for payload type Multi-part added
    - The GigE Producer now find devices connected to virtual interfaces for Linux

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 01 May 2019 22:00:00 -0000

ros-melodic-rc-genicam-api (2.1.2-1stretch) stretch; urgency=high

  * Remove global include_directories in cmake build files
  * Use full precision timestamp in name of images saved by gc_stream
  * Append out1 and out2 state to name of images saved by gc_stream



=== debian/control ===
Source: ros-melodic-rc-genicam-api
Section: misc
Priority: optional
Maintainer: Felix Ruess <felix.ruess@roboception.de>
Build-Depends: debhelper (>= 9.0.0), cmake, libpng-dev, libusb-1.0-0
Homepage: http://wiki.ros.org/rc_genicam_api
Standards-Version: 3.9.2

Package: ros-melodic-rc-genicam-api
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libpng-dev, libusb-1.0-0
Description: GenICam/GigE Vision Convenience Layer.
 This package combines the Roboception convenience layer for images with the GenICam reference implementation and a GigE Vision transport layer. It is a self contained package that permits configuration and image streaming of GenICam / GigE Vision 2.0 compatible cameras like the Roboception rc_visard. This package also provides some tools that can be called from the command line for discovering cameras, changing their configuration and streaming images. Although the tools are meant to be useful when working in a shell or in a script, their main purpose is to serve as example on how to use the API for reading and setting parameters, streaming and synchronizing images. See LICENSE.md for licensing terms of the different parts.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-rc-genicam-api//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install

## ros-melodic-rc-genicam-api 2.6.1

=== debian/changelog ===
ros-melodic-rc-genicam-api (2.6.1-1bionic) bionic; urgency=high

  * Fixed resetting of systems so that setSystemsPath() can be called again
  * Report reason if loading of producer fails
  * Fixed compiling under Windows
  * Fixed reading registers with size that is less than the requested size
  * Added convenience functions for loading and storing data on the camera via GenICam file interface

 -- Felix Ruess <felix.ruess@roboception.de>  Sun, 08 Jan 2023 23:00:00 -0000

ros-melodic-rc-genicam-api (2.6.0-1bionic) bionic; urgency=high

  * Upgraded GenAPI to version 3.4
  * Changed gc_file to read and write in blocks of 512 bytes and made FileSize parameter optional

 -- Felix Ruess <felix.ruess@roboception.de>  Tue, 08 Nov 2022 23:00:00 -0000

ros-melodic-rc-genicam-api (2.5.17-1bionic) bionic; urgency=high

  * Added building for Jammy
  * Added possibility to specify GenICam parameters on the command line of gc_pointcloud tool
  * README: change grep for newer netstat versions

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 12 Oct 2022 22:00:00 -0000

ros-melodic-rc-genicam-api (2.5.16-1bionic) bionic; urgency=high

  * Added CI build pipelines for ARM64
  * net_perf_check.sh use first default interface
  * Show enum options even if WriteOnly

 -- Felix Ruess <felix.ruess@roboception.de>  Sat, 28 May 2022 22:00:00 -0000

ros-melodic-rc-genicam-api (2.5.14-1bionic) bionic; urgency=high

  * Install licenses of included binaries
  * Reporting interface id instead of display name in output of gc_info -s

 -- Felix Ruess <felix.ruess@roboception.de>  Tue, 01 Feb 2022 23:00:00 -0000

ros-melodic-rc-genicam-api (2.5.13-1bionic) bionic; urgency=high

  * Added parameter '-s' to gc_info for getting a short list of discovered devices
  * Fixed Windows build script

 -- Felix Ruess <felix.ruess@roboception.de>  Sun, 30 Jan 2022 23:00:00 -0000

ros-melodic-rc-genicam-api (2.5.12-1bionic) bionic; urgency=high

  * Imporved Windows build script for compiling with libpng
  * Fixed some issues when compiling under Windows

 -- Felix Ruess <felix.ruess@roboception.de>  Fri, 22 Oct 2021 22:00:00 -0000

ros-melodic-rc-genicam-api (2.5.11-1bionic) bionic; urgency=high

  * Fixed getting buffers with chunk data from Basler ace2 USB cameras

 -- Felix Ruess <felix.ruess@roboception.de>  Mon, 04 Oct 2021 22:00:00 -0000

ros-melodic-rc-genicam-api (2.5.10-1bionic) bionic; urgency=high

  * Make system, interface, device and stream ignore closing already closed objects

 -- Felix Ruess <felix.ruess@roboception.de>  Thu, 30 Sep 2021 22:00:00 -0000

ros-melodic-rc-genicam-api (2.5.9-1bionic) bionic; urgency=high

  * Improved measuring of buffers per second in gc_stream
  * Do not show latency in gc_stream -t if PTP is turned off

 -- Felix Ruess <felix.ruess@roboception.de>  Thu, 30 Sep 2021 22:00:00 -0000

ros-melodic-rc-genicam-api (2.5.8-1bionic) bionic; urgency=high

  * Added support for YUV422_8 and YCbCr422_8 pixel formats

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 08 Sep 2021 22:00:00 -0000

ros-melodic-rc-genicam-api (2.5.7-1bionic) bionic; urgency=high

  * Added possibility to specify the internal number of buffers to allocate
  * gc_file tool: Exit with error if file cannot be loaded

 -- Felix Ruess <felix.ruess@roboception.de>  Tue, 31 Aug 2021 22:00:00 -0000

ros-melodic-rc-genicam-api (2.5.6-1bionic) bionic; urgency=high

  * Changed ImageList::find with tolerance > 0 to return the closest within tolerance

 -- Felix Ruess <felix.ruess@roboception.de>  Sun, 01 Aug 2021 22:00:00 -0000

ros-melodic-rc-genicam-api (2.5.5-1bionic) bionic; urgency=high

  * Fixed rounding when converting between color and monochrome images
  * Reduce minimum number of buffers
  * Do not attach chunk data handler to incomplete buffer

 -- Felix Ruess <felix.ruess@roboception.de>  Tue, 27 Jul 2021 22:00:00 -0000

ros-melodic-rc-genicam-api (2.5.4-1bionic) bionic; urgency=high

  * Fixed reporting of operation status of gc_file tool

 -- Felix Ruess <felix.ruess@roboception.de>  Sat, 24 Jul 2021 22:00:00 -0000

ros-melodic-rc-genicam-api (2.5.3-1bionic) bionic; urgency=high

  * Added build script for Visual Studio
  * Added methods for getting region id and data purpose id from buffer
  * On Windows, also try to find producers in sub directories of current library
  * Fixed some compiler warnings
  * Improved error message when writing on cport fails
  * Fixed conversion from YCbCr411 format to Mono8 in convertImage() function
  * Improved error message when setting invalid enum
  * Added support for RGB8 color format in getColor() function

 -- Felix Ruess <felix.ruess@roboception.de>  Fri, 16 Jul 2021 22:00:00 -0000

ros-melodic-rc-genicam-api (2.5.2-1bionic) bionic; urgency=high

  * Added possibility for configuration of multiple Gev interfaces in gc_config
  * Fixed printing of Mac address in gc_info
  * Added method to stream object for checking the number of buffers available for grabbing
  * Treating missing parameters in Buffer as 0
  * Changed way how to define different path for locating producers
  * Added possibility to discover producers in non-default locations and ignoring a specific producer
  * Added possibility to store xml file with gc_info with original name

 -- Felix Ruess <felix.ruess@roboception.de>  Mon, 05 Jul 2021 22:00:00 -0000

ros-melodic-rc-genicam-api (2.5.1-1bionic) bionic; urgency=high

  * Fixed compile problems under Windows
  * Fixed using wrong pointer in method Stream::getTLType()
  * Readme: Add link to release page
  * Removing redundent specification of namespace in some source files

 -- Felix Ruess <felix.ruess@roboception.de>  Mon, 15 Mar 2021 23:00:00 -0000

ros-melodic-rc-genicam-api (2.5.0-1bionic) bionic; urgency=high

  * Upgrading GenICam reference implementation to version 3.3
  * Added support for storing images of format RGB8 and BayerXX8
  * Increasing discover timeout from 100 ms to 1 s, which is necessary for some cameras


=== debian/rules ===
--- 
+++ 
@@ -17,9 +17,17 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
+endif
+
+# Solve shlibdeps errors in REP136 packages that use GNUInstallDirs:
+export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
+
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -28,7 +36,8 @@
 	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
 	dh_auto_configure -- \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"
+		-DCMAKE_PREFIX_PATH="/opt/ros/melodic" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -50,7 +59,7 @@
 	# in the install tree and source it.  It will set things like
 	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
 	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
-	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-rc-genicam-api//opt/ros/melodic/lib/
+	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-rc-genicam-api//opt/ros/melodic/lib/:$(CURDIR)/debian/ros-melodic-rc-genicam-api//opt/ros/melodic/lib/${DEB_HOST_MULTIARCH}
 
 override_dh_auto_install:
 	# In case we're installing to a non-standard location, look for a setup.sh
